#!/bin/bash

meFirmwareFile="11.8.50.3399.bin"

meFirmwareLocation="/ME-Flash/"
fwUpdLcl="FWUpdLcl"
fwUpdLclLocation=""
fwUpdLclLocation64="/ME-Flash/LINUX64/"
fwUpdLclLocation32="/ME-Flash/LINUX32/"
instructionsFile="README.txt"

answer="x"
output="nothing"

echo
echo "Updating Management Engine firmware will require a reboot in order for the update to be effective."
echo
echo "***WARNING: Installation of the Management Engine update tool RPM uses the --replacefiles parameter to ensure that the installation is successful.***"
echo

while [ "$answer" = "x" ]; do
	read -p "Do you want to update the Management Engine firmware now [Y/N]? " yn
	case $yn in
		[Yy] ) answer="y";;
		[Nn] ) answer="n";;
		*) echo "Please answer [Y]es or [N]o."; answer="x";;
	esac
done

echo

if [ "$answer" = "n" ]; then
	echo "Please refer to the $instructionsFile file (below) for instructions to manually update your Management Engine firmware"
	echo
	cat "./$instructionsFile"
	echo
	exit
fi

if [ "$answer" = "y" ]; then
	output=$(uname -m)
	if [ "$output" = "x86_64" ]; then
		fwUpdLclLocation=$fwUpdLclLocation64
	elif [ "$output" = "i686" ]; then
		fwUpdLclLocation=$fwUpdLclLocation32
	else
		echo "Cannot detect if this is a 32bit or 64bit operating system." 
		echo "Please refer to the $instructionsFile file (below) for instructions to manually update your Management Engine firmware."
		echo
		cat "./$instructionsFile"
		echo
		exit
	fi
	sudo chmod u+x .$fwUpdLclLocation$fwUpdLcl
	output=$(sudo .$fwUpdLclLocation$fwUpdLcl -fwver)
	output=$(echo $output | cut -d':' -f 3)
	echo "Your current Management Engine Firmware version: $output"
	output="${meFirmwareFile:0:-4}"
	echo "Updating to version: $output"
	echo
	echo "Management Engine firmware update initiated."
	sudo .$fwUpdLclLocation$fwUpdLcl -f ".$meFirmwareLocation$meFirmwareFile" -allowsv
	sudo chmod u-x .$fwUpdLclLocation$fwUpdLcl
	echo
	echo "Complete.  You must reboot in order for the update to be effective."
	echo
fi
